Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- Debugging
- Interface
- Lit
- Logic
- MatchAnalysis
- MatchApproximation
- MatchCodeGen
- MatchCps
- MatchOptimization
- MatchTranslation
- MatchTreeMaking
- MatchWarnings
- PatternExpander
- PatternMatching
- PatternMatchingStats
- ScalaLogic
- ScalacPatternExpanders
- Solving
- TreeAndTypeAnalysis

t

scala.tools.nsc.transform.patmat

# MatchCodeGen 

###

#### trait MatchCodeGen extends Interface

Factory methods used by TreeMakers to make the actual trees.

We have two modes in which to emit trees: optimized (the default) and pure (aka "virtualized": match is parametric in its monad).

Source
  MatchCodeGen.scala

Linear Supertypes
Interface, TreeDSL, AnyRef, Any
Known Subclasses
patmat, MatchAnalysis, MatchApproximation, MatchOptimization, MatchTreeMaking, PatternMatching
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MatchCodeGen
2. Interface
3. TreeDSL
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface
2.  trait TypedSubstitution extends MatchMonadInterface
   Definition Classes
     Interface
3.  trait CodegenCore extends MatchMonadInterface
4.  trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface
5.  trait PureCodegen extends CodegenCore with PureMatchMonadInterface
6.  trait PureMatchMonadInterface extends MatchMonadInterface

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     TreeDSL

### Concrete Value Members

1.  object CODE
   Definition Classes
     TreeDSL
2.  object vpmName
   Definition Classes
     Interface
3.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def ##(): Int
   Definition Classes
     AnyRef → Any
5.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from MatchCodeGen to any2stringadd[MatchCodeGen] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
6.  def ->[B](y: B): (MatchCodeGen, B)
   Implicit
     This member is added by an implicit conversion from MatchCodeGen to ArrowAssoc[MatchCodeGen] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
7.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
10.  final def dealiasWiden(tp: Global.Type): Global.Type
    Attributes
      protected
    Definition Classes
      Interface
11.  def ensuring(cond: (MatchCodeGen) ⇒ Boolean, msg: ⇒ Any): MatchCodeGen
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (MatchCodeGen) ⇒ Boolean): MatchCodeGen
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: ⇒ Any): MatchCodeGen
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): MatchCodeGen
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to StringFormat[MatchCodeGen] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
20.  final def hasStableSymbol(p: Global.Tree): Boolean
    Attributes
      protected
    Definition Classes
      Interface
21.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
22.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
23.  final def mkFALSE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
24.  final def mkTRUE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
25.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
26.  final def notify(): Unit
    Definition Classes
      AnyRef
27.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
28.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
29.  def toString(): String
    Definition Classes
      AnyRef → Any
30.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
33.  def →[B](y: B): (MatchCodeGen, B)
    Implicit
      This member is added by an implicit conversion from MatchCodeGen to ArrowAssoc[MatchCodeGen] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MatchCodeGen to any2stringadd[MatchCodeGen]

### Inherited by implicit conversion StringFormat from MatchCodeGen to StringFormat[MatchCodeGen]

### Inherited by implicit conversion Ensuring from MatchCodeGen to Ensuring[MatchCodeGen]

### Inherited by implicit conversion ArrowAssoc from MatchCodeGen to ArrowAssoc[MatchCodeGen]

### Ungrouped